import { MdcComponent, MdcFocusTrap } from '@aurelia2-mdc-web/base';
import { MDCDialogFoundation } from '@material/dialog';
import { MdcDialogContent } from './mdc-dialog-content';
/**
 * @selector mdc-dialog
 */
export declare class MdcDialog extends MdcComponent<MDCDialogFoundation> implements EventListenerObject {
    id: number;
    contentId: string;
    titleId: string;
    private buttons;
    mdcFocusTrap: MdcFocusTrap;
    content_?: MdcDialogContent[];
    /** Action returned when the dialog is closed via the scrim click */
    scrimClickAction: string;
    scrimClickActionChanged(): Promise<void>;
    /** Action returned when the dialog is closed via the ESC key */
    escapeKeyAction: string;
    escapeKeyActionChanged(): Promise<void>;
    delayFocusTrap: boolean;
    fullscreen: boolean;
    sheet: boolean;
    get defaultButton(): HTMLElement | null;
    get content(): HTMLElement | null;
    initialise(): Promise<void>;
    createFocusTrap(): void;
    destroy(): void;
    handleClick_(evt: MouseEvent): boolean;
    handleKeydown_(evt: KeyboardEvent): boolean;
    handleEvent(evt: Event): void;
    handleOpening_(): void;
    handleClosing_(): void;
    /** Opens the dialog */
    open(): void;
    /**
     * Closes the dialog
     * @param action Action to close the dialog with
     */
    close(action?: string): void;
    getDefaultFoundation(): MDCDialogFoundation;
    getInitialFocusEl: () => HTMLElement | null;
}
